org.eclipse.viatra.query.runtime.matchers.context

## Enum IndexingService

- java.lang.Object
- - java.lang.Enum<IndexingService>
  - - org.eclipse.viatra.query.runtime.matchers.context.IndexingService

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Comparable<IndexingService>

      public enum IndexingService
      extends java.lang.Enum<IndexingService>

  These are the different services which can be provided by an `IQueryRuntimeContext` implementation.
  Since:
    1.4

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `INSTANCES` Enables enumeration of instances and reverse-navigation.
    `NOTIFICATIONS` The indexer can provide notifications about changes in the model.
    `STATISTICS` Cardinality information is available.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static IndexingService` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static IndexingService[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### STATISTICS

          public static final IndexingService STATISTICS

      Cardinality information is available. Makes possible to calculate unseeded calls of `IQueryRuntimeContext#countTuples(IInputKey, org.eclipse.viatra.query.runtime.matchers.tuple.Tuple)`

    - #### NOTIFICATIONS

          public static final IndexingService NOTIFICATIONS

      The indexer can provide notifications about changes in the model.

    - #### INSTANCES

          public static final IndexingService INSTANCES

      Enables enumeration of instances and reverse-navigation.

  - ### Method Detail

    - #### values

          public static IndexingService[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (IndexingService c : IndexingService.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static IndexingService valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null